Bug 1252050 - Rewrite pcsd launch script
Rewrite pcsd launch script
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: pcs (Show other bugs)
7.2
Unspecified Unspecified
medium Severity unspecified
: rc
: ---
Assigned To: Ondrej Mular
cluster-qe@redhat.com
:
: 1315353 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-08-10 10:43 EDT by Radek Steiger
Modified: 2016-11-03 16:55 EDT (History)
4 users (show)

See Also:
Fixed In Version: pcs-0.9.151-1.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-11-03 16:55:09 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Radek Steiger 2015-08-10 10:43:58 EDT
> Description of problem:

While the current /usr/lib/pcsd/pcsd launch script in RHEL7 is based on a standard iniscript skeleton it doesn't work that way.  

When the start() is issued, instead of sending the ruby process into the background the script is kept running and ruby is spawned as a child of this script. As soon as systemd sends the TERM signal to the script to stop pcsd, it tries to terminate the child process tree as well. This often leads to the TERM signal being caugth twice in ruby resulting in a traceback:

Shutting down (TERM)
Shutting down (TERM)
/usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:48:in `shutdown': undefined method `shutdown' for nil:NilClass (NoMethodError)
        from /usr/lib/pcsd/ssl.rb:56:in `block in <main>'
        from /usr/share/ruby/webrick/log.rb:150:in `call'
        from /usr/share/ruby/webrick/log.rb:150:in `strftime'
        from /usr/share/ruby/webrick/log.rb:150:in `log'
        from /usr/share/ruby/webrick/log.rb:94:in `info'
        from /usr/share/ruby/webrick/server.rb:197:in `block in start'
        from /usr/share/ruby/webrick/server.rb:32:in `start'
        from /usr/share/ruby/webrick/server.rb:160:in `start'
        from /usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:34:in `run'
        from /usr/lib/pcsd/ssl.rb:62:in `<main>

I've tried disabling the termination of children processes in systemd, but it introduces a different issue with the ruby process getting stuck when the stop is issued shortly after startup.

Also, there's a stop() function in the startup script which doesn't seem to be doing anything at all and therefore cannot be used by systemd to shutdown pcsd correctly.


> Version-Release number of selected component (if applicable):

pcs-0.9.142-2.el7.x86_64


> Expected results:

We need either to rewrite the script so it can work a fully-feature iniscript or call pcsd daemon directly from systemd.
Comment 2 Tomas Jelinek 2016-03-07 10:30:28 EST
*** Bug 1315353 has been marked as a duplicate of this bug. ***
Comment 3 Mike McCune 2016-03-28 19:15:27 EDT
This bug was accidentally moved from POST to MODIFIED via an error in automation, please see mmccune@redhat.com with any questions
Comment 4 Ivan Devat 2016-05-31 08:16:36 EDT
Before fix:
[vm-rhel72-1 ~] $ rpm -q pcs
pcs-0.9.143-15.el7.x86_64

[vm-rhel72-1 ~] $ service pcsd status
Redirecting to /bin/systemctl status  pcsd.service
● pcsd.service - PCS GUI and remote configuration interface
   Loaded: loaded (/usr/lib/systemd/system/pcsd.service; disabled; vendor preset: disabled)
   Active: active (running) since Ne 2016-05-29 00:11:56 CEST; 53min ago
 Main PID: 24025 (pcsd)
   CGroup: /system.slice/pcsd.service
           ├─24025 /bin/sh /usr/lib/pcsd/pcsd start
           ├─24030 /bin/bash -c ulimit -S -c 0 >/dev/null 2>&1 ; /usr/bin/ruby -I/usr/lib/pcsd /usr/lib/pcsd/ssl.rb
           └─24031 /usr/bin/ruby -I/usr/lib/pcsd /usr/lib/pcsd/ssl.rb

kvě 29 00:11:56 vm-rhel72-1 systemd[1]: Starting PCS GUI and remote configuration interface...
kvě 29 00:11:56 vm-rhel72-1 systemd[1]: Started PCS GUI and remote configuration interface.


After Fix:
[vm-rhel72-1 ~] $ rpm -q pcs
pcs-0.9.151-1.el7.x86_64

[vm-rhel72-1 ~] $ service pcsd status
Redirecting to /bin/systemctl status  pcsd.service
● pcsd.service - PCS GUI and remote configuration interface
   Loaded: loaded (/usr/lib/systemd/system/pcsd.service; disabled; vendor preset: disabled)
   Active: active (running) since Ne 2016-05-29 01:05:11 CEST; 3s ago
 Main PID: 1844 (ruby)
   CGroup: /system.slice/pcsd.service
           └─1844 /usr/bin/ruby -C/var/lib/pcsd -I/usr/lib/pcsd -- /usr/lib/pcsd/ssl.rb > /dev/null &

kvě 29 01:05:11 vm-rhel72-1 systemd[1]: Started PCS GUI and remote configuration interface.
kvě 29 01:05:11 vm-rhel72-1 systemd[1]: Starting PCS GUI and remote configuration interface...
Comment 8 errata-xmlrpc 2016-11-03 16:55:09 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-2596.html

Note You need to log in before you can comment on or make changes to this bug.